#ifndef OPTIONS_H
#define OPTIONS_H
#include "video-device-info.h"
#include "video-audio-set.h"


typedef enum _OPTION_RESULT_
{
    OPTION_INVALID_PARAMS,
    OPTION_INVALID_OPTION,
    OPTION_OK,
    OPTION_FAILED,
    OPTION_NOT_EXIST_DEVICE,
    OPTION_ERROR_DEVICE_ID,
    OPTION_NO_DEVICE_OPTION,
} OPTION_RESULT;

typedef enum _OPTION_CMD_
{
    OPTION_CMD_USAGE,
    OPTION_CMD_LIST,

    OPTION_CMD_DEVICE,

    OPTION_CMD_VIDEO_INPUT_SET,
    OPTION_CMD_VIDEO_INPUT_ASPECT,
    OPTION_CMD_VIDEO_INPUT_COLOR_FORMAT,
    OPTION_CMD_VIDEO_INPUT_QUANTIZATION,

    OPTION_CMD_AUDIO_INPUT_SET,

    OPTION_CMD_EDID_READ,
    OPTION_CMD_EDID_WRITE,

    OPTION_CMD_LED_MODE,

    OPTION_CMD_TIMING_SAVE,
    OPTION_CMD_TIMING_SET,

    OPTION_CMD_PIXEL_BRIGHTNESS,
    OPTION_CMD_PIXEL_CONTRAST,
    OPTION_CMD_PIXEL_HUE,
    OPTION_CMD_PIXEL_SATURATION,

    OPTION_CMD_VIDEO_OUTPUT_DEINTERLACE,
    OPTION_CMD_VIDEO_OUTPUT_RECT,
    OPTION_CMD_VIDEO_OUTPUT_ASPECT,
    OPTION_CMD_VIDEO_OUTPUT_LOWLATENCY,
    OPTION_CMD_VIDEO_OUTPUT_COLOR_FORMAT,
    OPTION_CMD_VIDEO_OUTPUT_QUANTIZATION,
    OPTION_CMD_VIDEO_OUTPUT_SATURATION,
    OPTION_CMD_VIDEO_OUTPUT_ASPECT_CONVERT,
    OPTION_CMD_VIDEO_OUTPUT_SET_AS_PRESET,
    //OPTION_CMD_VIDEO_OUTPUT_RELOAD_PRESET,

    //add
    OPTION_CMD_AUTO_SCAN,
    OPTION_CMD_LINK_WITH_VIDEO,
    OPTION_CMD_AUTO_SAMPL_PHASE,
    OPTION_CMD_AUTO_HALIGN,
    OPTION_CMD_PHASE,


} OPTION_CMD;

extern unsigned int g_dwCMD;
extern int g_nVideoInputSource;
extern int g_nAudioInputSource;
extern int g_nAspectX;
extern int g_nAspectY;
extern int g_nVideoColorFormat;
extern int g_nVideoQuantization;
extern int g_nVideoSaturation;
extern int g_nBrightness;
extern int g_nContrast;
extern int g_nHue;
extern int g_nSaturation;
extern char g_szReadEDIDPath[256];
extern char g_szWriteEDIDPath[256];
extern int g_nLEDMode;
extern char g_szSetTimingPath[256];
extern char g_szSaveTimingPath[256];
extern int g_nVideoOutputDeinterlace;
extern RECT g_recVideoOutputRect;
extern int g_nOutputAspectX;
extern int g_nOutputAspectY;
extern BOOLEAN g_bLowlatency;
extern int g_nOutputColorFormat;
extern int g_nOutputQuantization;
extern int g_nOutputSaturation;
extern int g_nOutputAspectConvert;
//add
extern int g_nAutoScan;
extern int g_nLinkWithVideo;
extern int g_nAutoSamplPhase;
extern int g_nAutoHAlign;
extern int g_nPhase;

OPTION_RESULT ParseCommandLine(int argc, char *argv[]);
OPTION_RESULT ParseDeviceArgument(char *szArg);

OPTION_RESULT ParseVideoSetArgument(char *szArg);
OPTION_RESULT ParseAudioSetArgument(char *szArg);

OPTION_RESULT ParseVideoAspectArgument(char *szArg);
OPTION_RESULT ParseVideoColorFormatArgument(char *szArg);
OPTION_RESULT ParseVideoQuantizationArgument(char *szArg);

OPTION_RESULT ParseBrightnessArgument(char *szArg);
OPTION_RESULT ParseContrastArgument(char *szArg);
OPTION_RESULT ParseHueArgument(char *szArg);
OPTION_RESULT ParseSaturationArgument(char *szArg);

OPTION_RESULT ParseReadEDIDArgument(char *szArg);
OPTION_RESULT ParseWriteEDIDArgument(char *szArg);

OPTION_RESULT ParseLEDModeArgument(char *szArg);
OPTION_RESULT ParseSetTimingArgument(char *szArg);
OPTION_RESULT ParseSaveTimingArgument(char *szArg);

OPTION_RESULT ParseVideoOutputDeinterlaceArgument(char *szArg);
OPTION_RESULT ParseVideoOutputRectArgument(char *szArg);
OPTION_RESULT ParseVideoOutputAspectArgument(char *szArg);
OPTION_RESULT ParseVideoOutputLowlatencyArgument(char *szArg);
OPTION_RESULT ParseVideoOutputColorFormatArgument(char *szArg);
OPTION_RESULT ParseVideoOutputQuantizationArgument(char *szArg);
OPTION_RESULT ParseVideoOutputSaturationArgument(char *szArg);
OPTION_RESULT ParseVideoOutputAspectConvertArgument(char *szArg);

int getOptionInd(int argc, char *argv[]);

//add
OPTION_RESULT ParseVideoAutoScanArgument(char *szArg);
OPTION_RESULT ParseAudioLinkWithVideoArgument(char *szArg);

OPTION_RESULT ParseVideoAutoSamplPhase(char *szArg);
OPTION_RESULT ParseAudioAutoHAlign(char *szArg);
OPTION_RESULT ParsePhaseArgument(char *szArg);


void PrintUsage();

#endif // OPTIONS_H
