#ifndef VIDEO_AUDIO_SET_H
#define VIDEO_AUDIO_SET_H

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#include "lib-mw-capture.h"
#include "config.h"

bool SetVideoInputSource(char *szDevicePath, int c);
bool SetAudioInputSource(char *szDevicePath, int c);
bool SetVideoAspect(char *szDevicePath, int nAspectX, int nAspectY);
bool SetVideoColorFormat(char *szDevicePath, int nColorFormat);
bool SetVideoQuantization(char *szDevicePath, int nQuantization);

bool ReadEDID(char *szDevice, char *szEDIDFile);
bool WriteEDID(char *szDevice, char *szEDIDFile);

bool SetLEDMode(char *szDevice, int nMode);

bool SetTiming(char *szDevicePath, char *szInFileName);
bool SaveTiming(char *szDevicePath, char *szInFileNae);

int SetPixelBrightness(char *szDevicePath, int nBrightness);
int SetPixelContrast(char *szDevicePath, int nContrast);
int SetPixelHue(char *szDevicePath, int nHue);
int SetPixelSaturation(char *szDevicePath, int nSaturation);

int SetVideoOutputDeinterlace(char *szDevicePath, int nDeinterlace);
int SetVideoOutputRect(char *szDevicePath, RECT rect);
int SetVideoOutputAspect(char *szDevicePath, int X, int Y);
int SetVideoOutputLowlatency(char *szDevicePath, BOOLEAN bLowlatency);
int SetVideoOutputColorFormat(char *szDevicePath, int nColorFormat);
int SetVideoOutputQuantization(char *szDevicePath, int nQuantization);
int SetVideoOutputSaturation(char *szDevicePath, int nSaturation);
int SetVideoOutputAspectConvert(char *szDevicePath, int nAspectConvert);
int SetAsPreset(char *szDevicePath);
//int ReloadPreset(char *szDevicePath);

//add
bool SetVideoAutoScan(char *szDevicePath, int nAutoScan);
bool SetAudioLinkWithVideo(char *szDevicePath, int nLinkWithVideo);

bool SetAutoSamplPhase(char *szDevicePath, int nAutoSamplPhase);
bool SetAutoHAlign(char *szDevicePath, int nAutoHAlign);
int SetPhase(char *szDevicePath, int nPhase);

#endif // VIDEO_SET_H
