#ifndef CCAPTURETHREAD_H
#define CCAPTURETHREAD_H

#include "cffmpegencode.h"
#ifdef __cplusplus
extern "C"
{
#endif
#include <termios.h>
#include <pthread.h>
#include "lib-mw-capture.h"
#include "mw-fourcc.h"
#include "win-types.h"
#include "coptions.h"

#ifdef __cplusplus
}
#endif

#define   AAC_SAMPLES                 1024
#define   MAX_AUDIO_INPUT_SOURCE_NUM  5
#define   BIT_DEPTH_BYTE              4
#define   VIDEO_FORMAT                MWFOURCC_I420

class CCaptureThread
{
public:
    CCaptureThread();

public:
    BOOL InitCapture(char *szDevicePath, int nWidth, int nHeight);
    void ExitCapture();

    BOOL Create(int nWidth, int nHeight, int framerates, ICallback *pCallback);
    void Destory();

    BOOL CheckKey();

protected:
    BOOL StartVideoCapture();
    void StopVideoCapture();

    BOOL StartAudioCapture();
    void StopAudioCapture();

    static void *VideoCaptureProc(void *pvParam)
    {
        CCaptureThread *pThis = (CCaptureThread *)pvParam;
        pThis->VideoCaptureProcInternel();
        return NULL;
    }
    void VideoCaptureProcInternel();

    static void *AudioCaptureProc(void *pvParam)
    {
        CCaptureThread *pThis = (CCaptureThread *)pvParam;
        pThis->AudioCaptureProcInternel();
        return NULL;
    }
    void AudioCaptureProcInternel();

protected:
    //video
    int             m_cx;
    int             m_cy;
    int             m_dwFrameDuration;
    HCHANNEL        m_hChannel;
    DWORD           m_dwFourCC;
    DWORD           m_dwMinStride;
    DWORD           m_dwImageSize;
    HANDLE64        m_pbImage;
    MWCAP_PTR       m_hVideoCapEvent;
    MWCAP_PTR       m_hNotifyEvent;
    MWCAP_PTR       m_hTimerEvent;
    HTIMER          m_hTimer;
    HNOTIFY         m_hNotifyBuffered;

    //audio
    bool            m_bAudioCap;
    int             m_nPresentChannel;
    uint8_t         *m_audioBuf;
    MWCAP_PTR       m_hAudioNotifyEvent;
    HNOTIFY         m_hAudioNotify;

    ICallback       *m_callback;
    bool            m_bStopFlag;
    pthread_t       m_nThreadIDAudio;
    pthread_t       m_nThreadIDVideo;

};

#endif // CCAPTURETHREAD_H
