#ifndef COPTIONS_H
#define COPTIONS_H
#include "stdio.h"
#include "stdlib.h"
#include "regex.h"
#include "getopt.h"
#include "unistd.h"
#include "string.h"
typedef enum _OPTION_RESULT_
{
    OPTION_INVALID_PARAMS,
    OPTION_INVALID_OPTION,
    OPTION_OK,
    OPTION_FAILED,
    OPTION_NOT_EXIST_DEVICE,
    OPTION_ERROR_DEVICE_ID,
    OPTION_NO_DEVICE_OPTION,
} OPTION_RESULT;

typedef enum _OPTION_CMD_
{
    OPTION_CMD_USAGE,
    OPTION_CMD_CHANNEL,
    OPTION_CMD_RESOLUTION,
    OPTION_CMD_FRAME_RATE,
    OPTION_CMD_BITRATE,
    OPTION_CMD_LEVEL,
    OPTION_CMD_BFRAME,
    OPTION_CMD_IFRAME,
    OPTION_CMD_OUTPUT,

} OPTION_CMD;

typedef struct OPTIONS_TAG
{
    int             dwWidth;
    int             dwHeight;
    int             dwFPS;
    int             dwBitrate;
    int             dwProfile;
    int             dwBFrame;
    int             dwIFrames;
    int             dwMp4;
    char            szDevicePath[256];
    char            szOutputFileName[256];
    unsigned int    dwCmd;
}OPTIONS;

class COptions
{
public:
    COptions();
    OPTION_RESULT ParseCommondLine(int argc, char **argv);
    OPTIONS GetOptions(){return m_option;}

protected:
    void PrintUsage();
    OPTION_RESULT ParseDeviceNum(char *szArg);
    OPTION_RESULT ParseResolutionArgument(char *szArg);
    OPTION_RESULT ParseFrameRate(char *szArg);
    OPTION_RESULT ParseBitRate(char *szArg);
    OPTION_RESULT ParseLevel(char *szArg);
    OPTION_RESULT ParseBFrame(char *szArg);
    OPTION_RESULT ParseIFrame(char *szArg);
    OPTION_RESULT ParseOutput(char *szArg);

protected:
    OPTIONS m_option;
};

#endif // COPTIONS_H
