#ifndef CGROUPBOX_H
#define CGROUPBOX_H

#include <QGroupBox>
#include <QLabel>
#include <QComboBox>
#include <QWidget>
#include <QTimer>
#include "mwcapture.h"
#include "videorenderxcb.h"

#define DEFAULT_WIDTH 1920
#define DEFAULT_HEIGHT 1080
#define DEFAULT_FOURCC MWFOURCC_YUY2


class CGroupBox : public QGroupBox , public ICallback
{
    Q_OBJECT
public:
    explicit CGroupBox(QWidget *parent = 0);
    virtual ~CGroupBox();

    void setPicture(QString strPicName);
    void enableLowLatency(BOOL bLowLatency);

    virtual void VideoCaptureCallback(MWCAP_PTR pbImage, DWORD cbImage, void *pvParam);
    virtual void VideoSignalChangedCallback();

signals:
protected:
    //void paintEvent(QPaintEvent *event);

public slots:
    void onCurrentIndexChanged(int nIndex);
    void updateVideoSignalStatus();
    void updateLatencyInfo();

private:
    void createDeviceComboBox();


private:
    QComboBox   *m_cmbDevices;
    QLabel      *m_lblPic;

    QLabel      *m_lblSignalStatusTitle;
    QLabel      *m_lblSignalStatus;

    QLabel      *m_lblResolutionTitle;
    QLabel      *m_lblResolution;

    QLabel      *m_lblTotalScanSizeTitle;
    QLabel      *m_lblTotalScanSize;

    QLabel      *m_lblActiveAreaOffsetTitle;
    QLabel      *m_lblActiveAreaOffset;

    QLabel      *m_lblCaptureFormatTitle;
    QLabel      *m_lblCaptureFormat;

    QLabel      *m_lblCaptureLatencyTitle;
    QLabel      *m_lblCaptureLatency;

    QLabel      *m_lblTotalLatencyTitle;
    QLabel      *m_lblTotalLatency;

    QWidget     *m_wndPreview;

    BOOL        m_bLowLatency;

    // channel
    MWCapture       *m_mwCapture;

    // Renderer
    VideoRenderXCB  *m_xcbRenderer;

    // Timer
    QTimer          *m_timerLatencyInfo;
};

#endif // CGROUPBOX_H
