#!/bin/bash

#re-direction STDERR
exec 2>/dev/null

COMPARE_STRING="Status: install ok installed"

####################
#check libraries
####################
#libxcb
#PACKAGE_NAME=libxcb.\*
#PACKAGE_STATUS=`dpkg --get-selections | grep libxcb | wc -l`
#if [ $PACKAGE_STATUS -le 10 ]
#then
#	echo "'$PACKAGE_NAME' are currently not fully installed."
#else
#	echo "$PACKAGE_NAME: $COMPARE_STRING"
#fi

#libxrender-dev libxi-dev not necessary
for PACKAGE_NAME in qt5-default gcc libxcb1-dev libx11-xcb-dev mesa-common-dev libgl1-mesa-dev libglu1-mesa-dev
do
	PACKAGE_STATUS=`dpkg -s $PACKAGE_NAME | grep Status:`
	if [ "$PACKAGE_STATUS" == "$COMPARE_STRING" ]
	then
		echo "$PACKAGE_NAME: $PACKAGE_STATUS"	
	else
		echo "'$PACKAGE_NAME' is currently not installed."	
	fi
done

echo "NOTE: 'libxcb*' may not be fully installed!"


:<<"BLOCK
#####################
#Install Reference
#####################

#####Install compile environment

#qmake and Qt5  
sudo apt-get install qt5-default
#gcc
sudo apt-get install g++
#libxcb* 
sudo apt-get install "^libxcb.*" libx11-xcb-dev libxrender-dev libxi-dev
#openGL
sudo apt-get install mesa-common-dev
sudo apt-get install libgl1-mesa-dev libglu1-mesa-dev


#####or Install Qt5.5.1 QtCreator to Ubuntu.


MACHINE_WID=32;
XTAG=x86;
#32bits or 64bits: 
if [ $(getconf WORD_BIT) = '32' ] && [ $(getconf LONG_BIT) = '64' ] ; 
then
	MACHINE_WID=64;
	XTAG=x64;
else
	MACHINE_WID=32;
	XTAG=x86;
fi
#Download Qt5-Creator
wget http://download.qt.io/official_releases/qt/5.5/5.5.1/qt-opensource-linux-$XTAG-5.5.1.run
#Install Qt5
chmod +x qt-opensource-linux-$XTAG-5.5.1.run
./qt-opensource-linux-$XTAG-5.5.1.run
#Install g++
sudo apt-get install g++
#Install OpenGL
sudo apt-get install mesa-common-dev
sudo apt-get install libgl1-mesa-dev libglu1-mesa-dev
#Remove xxxx.run
rm qt-opensource-linux-$XTAG-5.5.1.run

"BLOCK
	




