#ifndef MAINVIEW_H
#define MAINVIEW_H

#include <QWidget>
#include<QLabel>
#include<QPushButton>
#include<QMutex>
#include<QVBoxLayout>
#include"videorenderxcb.h"
#include"mwcapture.h"
#include"settingsdlg.h"

class CMainView : public QWidget,public ICallback
{
    Q_OBJECT
public:
    explicit CMainView(QWidget *parent = 0);
    virtual ~CMainView();

    //Callback
    virtual void VideoCaptureCallback(MWCAP_PTR pbImage, DWORD cbImage, void *pvParam);
    virtual void VideoSignalChangedCallback();

signals:
    void sigSendFPS(QString strFPS);

public slots:
    void updateFPSInfo();

public:

    VideoRenderXCB  *m_xcbRender;
    MWCapture       *m_mwCapture;

    QMutex          m_lock;

    QTimer          *m_timerFPSInfo;
};

#endif // MAINVIEW_H
