#ifndef SETTINGSDLG_H
#define SETTINGSDLG_H

#include <QDialog>
#include<QHBoxLayout>
#include<QComboBox>
#include<QTableWidget>
#include<QPushButton>
#include<QLabel>
#include<QCheckBox>
#include <QGridLayout>
#include<QHeaderView>
#include<qsizepolicy.h>
#include "videorenderxcb.h"
#include "mwcapture.h"

#define DEFAULT_WIDTH 1920
#define DEFAULT_HEIGHT 1080
#define DEFAULT_FOURCC MWFOURCC_YUY2


struct st_size{
    int width;
    int height;
};

class CSettingsDlg:public QDialog
{
    Q_OBJECT
public:
    CSettingsDlg(QWidget *parent = 0);
    ~CSettingsDlg();

    void initStatus();
signals:
    void infoSend(CHANNEL_INDEX*,const int &,const int &,const struct st_size,const double &,bool);//btnOK to send

public slots:
    void onCurrentFormatIndexChanged(int nIndex);
    void onCurrentSizeIndexChanged(int nIndex);
    void onCurrentFPSIndexChanged(int nIndex);
    void onTableLineClick(int,int);
    void onPushButtonClickOK();
    void onPushButtonClickCancel();

private:
    void createDeviceTable();
    void updateCheckBox();

private:
    int m_nNumChannel;//channel number
    CHANNEL_INDEX m_stChannelsInfo[MAX_CHANNEL_COUNT];//channel info
    int m_nFormat;
    st_size m_stSize;
    double m_dFPS;

    MWCapture       *m_mwCapture;
    QString         m_strSignalStatus;
    QString         m_strResolution;

    //layout
    QHBoxLayout     *m_hblTop;
    QLabel          *m_labFormat;
    QComboBox       *m_cmbFormat;
    QHBoxLayout     *m_hblFormat;
    QLabel          *m_labSize;
    QComboBox       *m_cmbSize;
    QHBoxLayout     *m_hblSize;
    QLabel          *m_labFPS;
    QComboBox       *m_cmbFPS;
    QHBoxLayout     *m_hblFPS;
    QTableWidget    *m_table;
    QCheckBox       *m_chboxSync;
    QLabel          *m_labSync;
    QHBoxLayout     *m_hblCheck;
    QPushButton     *m_btnOK;
    QPushButton     *m_btnCancel;
    QHBoxLayout     *m_hblBtn;
    QHBoxLayout     *m_hblBottom;
    QVBoxLayout     *m_vblMain;
};

#endif // SETTINGSDLG_H
