#ifndef BITMAP_H
#define BITMAP_H
#include "win-types.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#pragma pack(push)
#pragma pack(1)
typedef struct tagBITMAPFILEHEADER{
    WORD bfType;
    DWORD bfSize;
    WORD bfReserved1;
    WORD bfReserved2;
    DWORD bfOffBits;
}BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER{
     DWORD biSize;
     DWORD biWidth;
     DWORD biHeight;
     WORD biPlanes;
     WORD biBitCount;
     DWORD biCompression;
     DWORD biSizeImage;
     DWORD biXPelsPerMeter;
     DWORD biYPelsPerMeter;
     DWORD biClrUsed;
     DWORD biClrImportant;
}BITMAPINFOHEADER;

static void create_bitmap(char *pFileName, unsigned char* pbFrame, int cbFrame, int cx, int cy)
{
        //set the file deader for bitmap file
        BITMAPFILEHEADER bitMapFileHeader;
        memset(&bitMapFileHeader,0,sizeof(BITMAPFILEHEADER));

        bitMapFileHeader.bfType = 0x4D42;
        bitMapFileHeader.bfSize = cbFrame + 54;//  m_cx*m_cy*3+sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)
        bitMapFileHeader.bfReserved1 = 0;
        bitMapFileHeader.bfReserved2 = 0;
        bitMapFileHeader.bfOffBits = 54;  //sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)

        //set the info header for Bitmap file
        BITMAPINFOHEADER bitMapInfoHeader;
        memset(&bitMapInfoHeader,0,sizeof(BITMAPINFOHEADER));

        bitMapInfoHeader.biSize = 40;//sizeof(BITMAPINFOHEADER)
        bitMapInfoHeader.biWidth = cx;//XI_CAPTURE_WIDTH
        bitMapInfoHeader.biHeight = cy;//XI_CAPTURE_HEIGHT
        bitMapInfoHeader.biPlanes = 1;
        bitMapInfoHeader.biBitCount = 32;
        bitMapInfoHeader.biCompression = 0;
        bitMapInfoHeader.biSizeImage = 0;
        bitMapInfoHeader.biXPelsPerMeter = 0;
        bitMapInfoHeader.biYPelsPerMeter = 0;
        bitMapInfoHeader.biClrUsed =0;
        bitMapInfoHeader.biClrImportant =0;

        //int nBitMapsize = m_cx*m_cy*3;

        //creae the BipMap file
        FILE *fd = fopen(pFileName,"wb");

        /*fwrite((const char *)&bitMapFileHeader.bfType,2,1,fd);
        fwrite((const char *)&bitMapFileHeader.bfSize,4,1,fd);
        fwrite((const char *)&bitMapFileHeader.bfReserved1,2,1,fd);
        fwrite((const char *)&bitMapFileHeader.bfReserved2,2,1,fd);
        fwrite((const char *)&bitMapFileHeader.bfOffBits,4,1,fd);




        fwrite( (const char *)&bitMapInfoHeader.biSize,4,1,fd);
        fwrite( (const char *)&bitMapInfoHeader.biWidth,4,1,fd);
        fwrite( (const char *)&bitMapInfoHeader.biHeight,4,1,fd);
        fwrite( (const char *)&bitMapInfoHeader.biPlanes,2,1,fd);
        fwrite( (const char *)&bitMapInfoHeader.biBitCount,2,1,fd);
        fwrite( (const char *)&bitMapInfoHeader.biCompression,4,1,fd);
        fwrite( (const char *)&bitMapInfoHeader.biSizeImage,4,1,fd);
        fwrite( (const char *)&bitMapInfoHeader.biXPelsPerMeter,4,1,fd);
        fwrite( (const char *)&bitMapInfoHeader.biYPelsPerMeter,4,1,fd);
        fwrite( (const char *)&bitMapInfoHeader.biClrUsed,4,1,fd);
        fwrite( (const char *)&bitMapInfoHeader.biClrImportant,4,1,fd);

        ReverseBuffer();*/
        fwrite((const char *)&bitMapFileHeader, sizeof(BITMAPFILEHEADER), 1, fd);
        fwrite((const char *)&bitMapInfoHeader, sizeof(BITMAPINFOHEADER),1 ,fd);

        fwrite((const char *)pbFrame,cbFrame,1,fd);

        fclose(fd);

}







#pragma pack(pop)
#endif // BITMAP_H
