
#include <stdio.h>
#include <getopt.h>
#include <unistd.h>
#include <regex.h>
#include "options.h"
#include "video-device-info.h"

static const char short_options[] = "hlpv";
static const struct option long_options[] =
{
    {"png",         no_argument, NULL,    'p'},
    {"video",       no_argument, NULL,    'v'},

    {0,             0,           0,        0},
};

unsigned int g_dwCMD = 0;

OPTION_RESULT ParseCommandLine(int argc, char *argv[])
{
    OPTION_RESULT opr = OPTION_OK;
    int nIdx;
    int c;
    while ((c = getopt_long(argc, argv, short_options, long_options, &nIdx)) != -1)
    {
        if (c == '?')
            return OPTION_INVALID_OPTION;

        switch (c)
        {
        case 'h':
        {
            g_dwCMD |= (0x01 << OPTION_CMD_USAGE);
        }
            break;
        case 'l':
        {
            g_dwCMD |= (0x01 << OPTION_CMD_LIST);
            SelectAllVideoDevices();
        }
            break;
        case 'p':
        {
            g_dwCMD |= (0x01 << OPTION_CMD_OSD_PNG);

        }
            break;
        case 'v':
        {
            g_dwCMD |= (0x01 << OPTION_CMD_OSD_VIDEO);
        }
            break;
        default:
            break;
        }

        if (opr != OPTION_OK)
            return opr;
    }

    return opr;
}

void PrintUsage()
{
    printf("USAGE\n"
           "  mwcap-osd [OPTIONS]\n\n"
           "DESCRIPTION\n"
           "  Capture video frame with OSD.\n\n"
           "OPTIONS\n"
           "  -h                                            print usage (Default option)\n"
           "  -l                                            list all capture device information\n\n"
           "  -p --png                                      load a PNG file as a OSD image\n"
           "  -v --video                                    capture a video frame as a OSD iamge\n"
           );
}
