#ifndef OPTIONS_H
#define OPTIONS_H
#include <stdbool.h>
#include "win-types.h"
#include "mw-fourcc.h"
#include "lib-mw-capture.h"

typedef enum _OPTION_RESULT_
{
    OPTION_INVALID_PARAMS,
    OPTION_INVALID_OPTION,
    OPTION_OK,
    OPTION_FAILED,
    OPTION_NOT_EXIST_DEVICE,
    OPTION_ERROR_DEVICE_ID,
    OPTION_NO_DEVICE_ARGUMENT,
    OPTION_NOT_SUPPORTED_COLOR_SAPCE,
} OPTION_RESULT;

typedef enum _OPTION_CMD_
{
    OPTION_CMD_USAGE,
    OPTION_CMD_LIST,

    OPTION_CMD_INPUT_ASPECT,
    OPTION_CMD_INPUT_COLOR_FORMAT,
    OPTION_CMD_INPUT_QUANTIZATION,

    OPTION_CMD_CAPTURE,

} OPTION_CMD;

typedef enum _RENDERER_TYPE_
{
    RENDERER_TYPE_NULL,
    RENDERER_TYPE_XCB,

} RENDERER_TYPE;

extern unsigned int g_dwCMD;


extern int g_nWidth;
extern int g_nHeight;
extern DWORD g_dwColorSpace;
extern float g_fFrameRate;
extern int g_nOutputRenderer;

extern int g_nInputAspectX;
extern int g_nInputAspectY;
extern int g_nInputColorFormat;
extern int g_nInputQuantization;

extern DWORD g_dwTime;


OPTION_RESULT ParseCommandLine(int argc, char *argv[]);
OPTION_RESULT ParseDeviceArgument(char *szArg);

OPTION_RESULT ParseVideoAspectArgument(char *szArg);
OPTION_RESULT ParseVideoColorFormatArgument(char *szArg);
OPTION_RESULT ParseVideoQuantizationArgument(char *szArg);

OPTION_RESULT ParseOutputRendererArgument(char *szArg);
OPTION_RESULT ParseOutputColorSpace(char *szArg);
OPTION_RESULT ParseOutputFramerate(char *szArg);
OPTION_RESULT ParseOutputResolution(char *szArg);

OPTION_RESULT ParseCaptureTimeArgument(char *szArg);
void PrintUsage();

#endif // OPTIONS_H
