#include "Cdlgampproc.h"
CDlgAmpproc::CDlgAmpproc(QWidget *parent) : QWidget(parent)
{
    m_shFile = new CGenerateSHFile(this);

    m_sldBrightness = new QSlider(Qt::Horizontal, this);
    m_sldBrightness->setStyleSheet("");
    m_sldContract = new QSlider(Qt::Horizontal, this);
    m_sldHue = new QSlider(Qt::Horizontal, this);
    m_sldSaturation = new QSlider(Qt::Horizontal, this);

    m_editBrightness = new QLineEdit(this);
    m_editContract = new QLineEdit(this);
    m_editHue = new QLineEdit(this);
    m_editSaturation = new QLineEdit(this);

    QLabel *pLblBrightness = new QLabel("Brightness :", this);
    QLabel *pLblContract = new QLabel("Contract :", this);
    QLabel *pLblHue = new QLabel("Hue :", this);
    QLabel *pLblSaturation = new QLabel("Saturation :", this);

    m_btnDefault = new QPushButton("Default", this);

    m_sldBrightness->setRange(-100, 100);
    m_sldHue->setRange(-90, 90);
    m_sldSaturation->setRange(0, 200);
    m_sldContract->setRange(50, 200);

    m_editBrightness->setEnabled(false);
    m_editContract->setEnabled(false);
    m_editHue->setEnabled(false);
    m_editSaturation->setEnabled(false);

//    this->setLayout(pVlay);
    int nIndex = 0;
    QGridLayout *pGlayout = new QGridLayout;
    pGlayout->addWidget(pLblBrightness, nIndex, 0);
    pGlayout->addWidget(m_sldBrightness, nIndex, 1);
    pGlayout->addWidget(m_editBrightness, nIndex, 2);
    m_editBrightness->setFixedWidth(40);

    ++ nIndex;
    pGlayout->addWidget(pLblHue, nIndex, 0);
    pGlayout->addWidget(m_sldHue, nIndex, 1);
    pGlayout->addWidget(m_editHue, nIndex, 2);
    m_editHue->setFixedWidth(40);

    ++ nIndex;
    pGlayout->addWidget(pLblSaturation, nIndex, 0);
    pGlayout->addWidget(m_sldSaturation, nIndex, 1);
    pGlayout->addWidget(m_editSaturation, nIndex, 2);
    m_editSaturation->setFixedWidth(40);

    ++ nIndex;
    pGlayout->addWidget(pLblContract, nIndex, 0);
    pGlayout->addWidget(m_sldContract, nIndex, 1);
    pGlayout->addWidget(m_editContract, nIndex, 2);
    m_editContract->setFixedWidth(40);

    QHBoxLayout *pHlayDefaultBtn = new QHBoxLayout;
    pHlayDefaultBtn->addStretch();
    pHlayDefaultBtn->addWidget(m_btnDefault);
    pHlayDefaultBtn->addStretch();

    QVBoxLayout *pVlayMain = new QVBoxLayout;
    pVlayMain->addLayout(pGlayout);
    pVlayMain->addLayout(pHlayDefaultBtn);
    pVlayMain->addStretch();

    m_sldBrightness->setFocusPolicy(Qt::NoFocus);
    m_sldContract->setFocusPolicy(Qt::NoFocus);
    m_sldHue->setFocusPolicy(Qt::NoFocus);
    m_sldSaturation->setFocusPolicy(Qt::NoFocus);

    this->setLayout(pVlayMain);

    QApplication::connect(m_sldBrightness, SIGNAL(valueChanged(int)), this, SLOT(onBrightnessValueChanged(int)));
    QApplication::connect(m_sldHue, SIGNAL(valueChanged(int)), this, SLOT(onHueValueChanged(int)));
    QApplication::connect(m_sldSaturation, SIGNAL(valueChanged(int)), this, SLOT(onSaturationValueChanged(int)));
    QApplication::connect(m_sldContract, SIGNAL(valueChanged(int)), this, SLOT(onContractValueChanged(int)));
    QApplication::connect(m_btnDefault, SIGNAL(clicked(bool)), this, SLOT(onBtnDefaultClicked()));

    m_sldBrightness->setValue(1);
    m_sldHue->setValue(1);

    onBtnDefaultClicked();
}


//slots
void CDlgAmpproc::onBrightnessValueChanged(int nValue)
{
    m_editBrightness->setText(QString("%1").arg(nValue));
    g_capture.SetVideoBrightness(nValue);
    g_capture.SetAmpBrightness(nValue);
}

void CDlgAmpproc::onHueValueChanged(int nValue)
{
    m_editHue->setText(QString("%1").arg(nValue));
    g_capture.SetVideoHue(nValue);
    g_capture.SetAmpHue(nValue);

}

void CDlgAmpproc::onSaturationValueChanged(int nValue)
{
    m_editSaturation->setText(QString("%1").arg(nValue));
    g_capture.SetVideoSaturation(nValue);
    g_capture.SetAmpSaturation(nValue);
}

void CDlgAmpproc::onContractValueChanged(int nValue)
{
    m_editContract->setText(QString("%1").arg(nValue));
    g_capture.SetVideoContract(nValue);
    g_capture.SetAmpContract(nValue);
}

void CDlgAmpproc::onBtnDefaultClicked()
{
    m_sldBrightness->setValue(0);
    m_sldHue->setValue(0);
    m_sldSaturation->setValue(100);
    m_sldContract->setValue(100);

}
