#ifndef CDLGHDIMI_H
#define CDLGHDIMI_H
#include <QWidget>
#include "publicheaders.h"
#include "cvideochannel.h"
#include "isignalnotify.h"
#include "cgenerateshfile.h"

class CDlgHDIMI : public QWidget,public ISignalNotify
{
    Q_OBJECT
public:
    explicit CDlgHDIMI(QWidget *parent = 0);

    void UpdateHDMI()
    {
        if(GetSystemEdid() == false)
        {
            QMessageBox::warning(this, "HDMI", "Read System EDID Failed !");
        }
        onHDMIInfoChanged();
        DeviceChange();
    }
    void DeviceChange();

    // ISignalNotify
    virtual void onHDMIInfoStatuChanged(unsigned long long ullStatusBits);


protected:
    QString UpdateHDMIInfo( MWCAP_HDMI_INFOFRAME_ID hdmiInfoID);
    void Num2HexStr(int nNum, char* pszBegin);
    bool GetSystemEdid();

protected:
    QTextEdit       *m_editEDID;
    QPushButton     *m_btnReset;
    QPushButton     *m_btnLoad;
    QPushButton     *m_btnSave;
    QTabWidget      *m_tabSub;
    QLabel          *m_lblAVI;
    QLabel          *m_lblAudio;
    QLabel          *m_lblSPD;
    QLabel          *m_lblMS;
    QLabel          *m_lblVS;
    QLabel          *m_lblACP;
    QLabel          *m_lblISRC1;
    QLabel          *m_lblISRC2;
    QLabel          *m_lblGamut;
    BYTE            m_bySysEdid[1024];
    ULONG           m_ulEdidCount;
    QString         m_strFileDir;

    CGenerateSHFile *m_shFile;

signals:
    void sigHDMIInfoChanged();
public slots:
    void onBtnResetClicked();
    void onBtnLoadClicked();
    void onBtnSaveClicked();

    void onHDMIInfoChanged();
};

#endif // CDLGHDIMI_H
