#include "cdlgtiming.h"
#include <QDebug>
CDlgTiming::CDlgTiming(QWidget *parent) : QWidget(parent)
{
    m_nSelTableResolution = 0;
    m_nSelTableTiming = 0;
    m_bDeleteFlag = true;

    m_ckbAutoSampling = new QCheckBox("Auto sampling phase");
    m_ckbAutoAlign = new QCheckBox("Auto horizontal alignment");
    m_ckbAutoSampling->setFocusPolicy(Qt::NoFocus);
    m_ckbAutoAlign->setFocusPolicy(Qt::NoFocus);

//    m_ckbAutoSampling->setStyleSheet("QCheckBox{background-color:transparent}");
//    m_ckbAutoAlign->setStyleSheet("QCheckBox{background-color:transparent}");

    QVBoxLayout *pVlayoutAuto = new QVBoxLayout;
    pVlayoutAuto->addWidget(m_ckbAutoSampling);
    pVlayoutAuto->addWidget(m_ckbAutoAlign);

    QGroupBox *pgpboxAuto = new QGroupBox("Auto adjust", this);
    pgpboxAuto->setLayout(pVlayoutAuto);

    QLabel *plblPhase = new QLabel("Phase:", this);
    m_spinPhase = new QSpinBox(this);
    m_spinPhase->setRange(0, 63);
    m_spinPhase->setEnabled(false);
    m_btnAutoPhaseAdjust = new QPushButton("Auto phase adjust");

    QGridLayout *playoutPhase = new QGridLayout;
    playoutPhase->addWidget(plblPhase, 0, 0);
    playoutPhase->addWidget(m_spinPhase, 0, 1);
    playoutPhase->addWidget(m_btnAutoPhaseAdjust, 1, 0, 1, 2);

    QGroupBox *pgpboxPhase = new QGroupBox("Phase", this);
    pgpboxPhase->setLayout(playoutPhase);

    QTabWidget *ptabTiming = new QTabWidget(this);
    QWidget *pwndAdjustTiming = new QWidget(this);
    QWidget *pwndCustomTimings = new QWidget(this);
    QWidget *pwndResolutions = new QWidget(this);

    //Adjust timing layout
    m_lblTimingInfo = new QLabel("N/A", this);
    m_btnPreferred = new QPushButton("Preferred timings", this);
    QHBoxLayout *pHlayoutPreferred = new QHBoxLayout;
    pHlayoutPreferred->addWidget(m_lblTimingInfo);
    pHlayoutPreferred->addStretch();
    pHlayoutPreferred->addWidget(m_btnPreferred);

    QLabel *plblHActive = new QLabel("H active:", this);
    m_barHActive = new QScrollBar(Qt::Horizontal, this);
    m_barHActive->setStyleSheet("QScrollBar:horizontal{border: 1px solid grey;}");
    m_lblHActive = new QLabel("N/A", this);
    m_lblHActive->setAlignment(Qt::AlignRight);

    QLabel *plblHTotal = new QLabel("H total:", this);
    m_barHTotal = new QScrollBar(Qt::Horizontal,this);
    m_barHTotal->setStyleSheet("QScrollBar:horizontal{border: 1px solid grey;}");
    m_lblHTotal = new QLabel("N/A", this);
    m_lblHTotal->setAlignment(Qt::AlignRight);

    QLabel *plblHOffset = new QLabel("H offset:", this);
    m_barHOffset = new QScrollBar(Qt::Horizontal, this);
    m_barHOffset->setStyleSheet("QScrollBar:horizontal{border: 1px solid grey;}");
    m_lblHOffset = new QLabel("N/A", this);
    m_lblHOffset->setAlignment(Qt::AlignRight);

    QLabel *plblVActive = new QLabel("V active:", this);
    m_barVActive = new QScrollBar(Qt::Horizontal, this);
    m_barVActive->setStyleSheet("QScrollBar:horizontal{border: 1px solid grey;}");
    m_lblVActive = new QLabel("N/A", this);
    m_lblVActive->setAlignment(Qt::AlignRight);

    QLabel *plblVOffset = new QLabel("V offset:", this);
    m_barVOffset = new QScrollBar(Qt::Horizontal, this);
    m_barVOffset->setStyleSheet("QScrollBar:horizontal{border: 1px solid grey;}");
    m_lblVOffset = new QLabel("N/A", this);
    m_lblVOffset->setAlignment(Qt::AlignRight);

    QLabel *plblClampPos = new QLabel("Clamp position:", this);
    m_barClampPos = new QScrollBar(Qt::Horizontal, this);
    m_barClampPos->setStyleSheet("QScrollBar:horizontal{border: 1px solid grey;}");
    m_lblClampPos = new QLabel("N/A", this);
    m_lblClampPos->setAlignment(Qt::AlignRight);

    QLabel *plblAspect = new QLabel("Aspect ratio:", this);
    QLabel *plblColon = new QLabel(":", this);
    m_spinAspectX = new QSpinBox(this);
    m_spinAspectY = new QSpinBox(this);
    m_spinAspectX->setRange(1, 2048);
    m_spinAspectY->setRange(1, 2048);
    m_spinAspectX->setFocusPolicy(Qt::NoFocus);
    m_spinAspectY->setFocusPolicy(Qt::NoFocus);
    QHBoxLayout *pHlayoutAspect = new QHBoxLayout;
    pHlayoutAspect->addWidget(m_spinAspectX);
    pHlayoutAspect->addWidget(plblColon);
    pHlayoutAspect->addWidget(m_spinAspectY);

    QGridLayout *pglayoutTiming = new QGridLayout;
    int num = 0;
    pglayoutTiming->addWidget(plblHActive, num, 0, 1, 2);
    pglayoutTiming->addWidget(m_barHActive, num, 2, 1, 5);
    pglayoutTiming->addWidget(m_lblHActive, num, 7, 1, 1);

    ++ num;
    pglayoutTiming->addWidget(plblHTotal, num, 0, 1, 2);
    pglayoutTiming->addWidget(m_barHTotal, num, 2, 1, 5 );
    pglayoutTiming->addWidget(m_lblHTotal, num, 7, 1, 1);

    ++ num;
    pglayoutTiming->addWidget(plblHOffset, num, 0, 1, 2);
    pglayoutTiming->addWidget(m_barHOffset, num, 2, 1, 5);
    pglayoutTiming->addWidget(m_lblHOffset, num, 7, 1, 1);

    ++ num;
    pglayoutTiming->addWidget(plblVActive, num, 0, 1, 2);
    pglayoutTiming->addWidget(m_barVActive, num, 2, 1, 5);
    pglayoutTiming->addWidget(m_lblVActive, num, 7, 1, 1);

    ++ num;
    pglayoutTiming->addWidget(plblVOffset, num, 0, 1, 2);
    pglayoutTiming->addWidget(m_barVOffset, num, 2, 1, 5);
    pglayoutTiming->addWidget(m_lblVOffset, num, 7, 1, 1);

    ++ num;
    pglayoutTiming->addWidget(plblClampPos, num, 0, 1, 2);
    pglayoutTiming->addWidget(m_barClampPos, num, 2, 1, 5);
    pglayoutTiming->addWidget(m_lblClampPos, num, 7, 1, 1);

    ++ num;
    pglayoutTiming->addWidget(plblAspect, num, 0, 1, 2);
    pglayoutTiming->addLayout(pHlayoutAspect, num, 2, 1, 1);

    m_btnResetTiming = new QPushButton("Reset timing", this);
    m_btnSaveTiming = new QPushButton("Save as custom timing", this);
    QHBoxLayout *pHlayoutBottom = new QHBoxLayout;
    pHlayoutBottom->addStretch();
    pHlayoutBottom->addWidget(m_btnResetTiming);
    pHlayoutBottom->addWidget(m_btnSaveTiming);

    QVBoxLayout *pVlayoutAdjust = new QVBoxLayout;
    pVlayoutAdjust->addLayout(pHlayoutPreferred);
    pVlayoutAdjust->addLayout(pglayoutTiming);
    pVlayoutAdjust->addLayout(pHlayoutBottom);
    pVlayoutAdjust->addStretch();
    pwndAdjustTiming->setLayout(pVlayoutAdjust);

    //Custom timings
    m_tableTimings = new CTableWidget(this);
    m_btnDeleteTimings = new QPushButton("Delete", this);
    m_btnDeleteTimings->setEnabled(false);

    QStringList lstTableHeaders;
    lstTableHeaders << "Mode" << "Total scan" << "Sync signal";
    m_tableTimings->setSelectionBehavior(QAbstractItemView::SelectRows);
    m_tableTimings->setSelectionMode(QAbstractItemView::ExtendedSelection);
    m_tableTimings->setEditTriggers(QAbstractItemView::NoEditTriggers);
    m_tableTimings->setColumnCount(lstTableHeaders.size());
    m_tableTimings->setHorizontalHeaderLabels(lstTableHeaders);
    m_tableTimings->horizontalHeader()->setStretchLastSection(true);

    QHBoxLayout *pHlayoutDelete = new QHBoxLayout;
    pHlayoutDelete->addStretch();
    pHlayoutDelete->addWidget(m_btnDeleteTimings);

    QVBoxLayout *pVlayoutCustom = new QVBoxLayout;
    pVlayoutCustom->addWidget(m_tableTimings);
    pVlayoutCustom->addLayout(pHlayoutDelete);
    pwndCustomTimings->setLayout(pVlayoutCustom);

    m_tableTimings->setColumnWidth(0, 150);
    m_tableTimings->setColumnWidth(1, 150);

    //Custom resolutions
    m_tableResolutions = new CTableWidget(this);
    m_btnAdd = new QPushButton("Add...", this);
    m_btnModify = new QPushButton("Modify...", this);
    m_btnDelete = new QPushButton("Delete", this);
    m_btnModify->setEnabled(false);
    m_btnDelete->setEnabled(false);
    QStringList lstResHeader;
    lstResHeader << "Resolutions";
    m_tableResolutions->setSelectionBehavior(QAbstractItemView::SelectRows);
    m_tableResolutions->setSelectionMode(QAbstractItemView::ExtendedSelection);
    m_tableResolutions->setEditTriggers(QAbstractItemView::NoEditTriggers);
    m_tableResolutions->setColumnCount(lstResHeader.size());
    m_tableResolutions->setHorizontalHeaderLabels(lstResHeader);
    m_tableResolutions->horizontalHeader()->setStretchLastSection(true);

    QHBoxLayout *pHLayoutResBottom = new QHBoxLayout;
    pHLayoutResBottom->addStretch();
    pHLayoutResBottom->addWidget(m_btnAdd);
    pHLayoutResBottom->addWidget(m_btnModify);
    pHLayoutResBottom->addWidget(m_btnDelete);

    QVBoxLayout *pVLayoutResolution = new QVBoxLayout;
    pVLayoutResolution->addWidget(m_tableResolutions);
    pVLayoutResolution->addLayout(pHLayoutResBottom);
    pwndResolutions->setLayout(pVLayoutResolution);

    ptabTiming->addTab(pwndAdjustTiming, "Adjust timing");
    ptabTiming->addTab(pwndCustomTimings, "Custom timings");
    ptabTiming->addTab(pwndResolutions, "Custom GTF/CVT resolutions");
    ptabTiming->setFocusPolicy(Qt::NoFocus);

    QHBoxLayout *playoutTop = new QHBoxLayout;
    playoutTop->addWidget(pgpboxAuto, 2);
    playoutTop->addWidget(pgpboxPhase, 1);

    QVBoxLayout *playoutMain = new QVBoxLayout;
    playoutMain->addLayout(playoutTop);
    playoutMain->addWidget(ptabTiming);

    this->setLayout(playoutMain);

    m_shFile = new CGenerateSHFile(this);
    g_capture.AddNotify(this);

    UpdateTiming();

    QApplication::connect(this, SIGNAL(sigTimingStatuChanged(unsigned long long)), this, SLOT(onTimingStatuChangedMain(unsigned long long)));
    QApplication::connect(m_tableTimings, SIGNAL(sigInEvent(bool)), this, SLOT(onFocusInTiming(bool)));
    QApplication::connect(m_tableResolutions, SIGNAL(sigInEvent(bool)), this, SLOT(onFocusInResolution(bool)));
}

void CDlgTiming::UpdateTiming()
{
    QApplication::disconnect(m_ckbAutoSampling, SIGNAL(stateChanged(int)), this, SLOT(onAutoSamplingChecked(int )));
    QApplication::disconnect(m_ckbAutoAlign, SIGNAL(stateChanged(int)), this, SLOT(onAutoHAlignChecked(int )));
    QApplication::disconnect(m_spinPhase, SIGNAL(valueChanged(int)), this, SLOT(onPhaseValueChanged(int )));
    QApplication::disconnect(m_btnAutoPhaseAdjust, SIGNAL(clicked(bool)), this, SLOT(onAutoPhaseAdjustClicked(bool)));

    QApplication::disconnect(m_btnPreferred, SIGNAL(clicked(bool)), this, SLOT(onPreferredTimingClicked(bool)));

    QApplication::disconnect(m_barHActive, SIGNAL(valueChanged(int)), this, SLOT(onHActiveChange(int )));
    QApplication::disconnect(m_barHTotal, SIGNAL(valueChanged(int)), this, SLOT(onHTotalChange(int )));
    QApplication::disconnect(m_barHOffset, SIGNAL(valueChanged(int)), this, SLOT(onHOffsetChange(int )));
    QApplication::disconnect(m_barVActive, SIGNAL(valueChanged(int)), this, SLOT(onVActiveChange(int )));
    QApplication::disconnect(m_barVOffset, SIGNAL(valueChanged(int)), this, SLOT(onVOffsetChange(int )));
    QApplication::disconnect(m_barClampPos, SIGNAL(valueChanged(int)), this, SLOT(onClampPosChange(int )));

    QApplication::disconnect(m_spinAspectX, SIGNAL(valueChanged(int)), this, SLOT(onAspectXValueChanged(int )));
    QApplication::disconnect(m_spinAspectY, SIGNAL(valueChanged(int)), this, SLOT(onAspectYValueChanged(int )));

    QApplication::disconnect(m_btnResetTiming, SIGNAL(clicked(bool)), this, SLOT(onResetTimingClicked(bool)));
    QApplication::disconnect(m_btnSaveTiming, SIGNAL(clicked(bool)), this, SLOT(onSaveTimingClicked(bool)));

    QApplication::disconnect(m_btnDeleteTimings, SIGNAL(clicked(bool)), this, SLOT(onTimingsDeleteClicked(bool)));
    QApplication::disconnect(m_btnAdd, SIGNAL(clicked(bool)), this, SLOT(onResolutionsAddClicked(bool)));
    QApplication::disconnect(m_btnModify, SIGNAL(clicked(bool)), this, SLOT(onResolutionsModifyClicked(bool)));
    QApplication::disconnect(m_btnDelete, SIGNAL(clicked(bool)), this, SLOT(onResolutionsDeleteClicked(bool)));

    QApplication::disconnect(m_tableTimings, SIGNAL(itemSelectionChanged()), this, SLOT(onTableTimingsItemClicked()));
    QApplication::disconnect(m_tableResolutions, SIGNAL(itemSelectionChanged()), this, SLOT(onTableResolutionsItemClicked()));

    UpdateTimingSettings();
    UpdateTableTiming();
    UpdateTableResolution();

    QApplication::connect(m_ckbAutoSampling, SIGNAL(stateChanged(int)), this, SLOT(onAutoSamplingChecked(int )));
    QApplication::connect(m_ckbAutoAlign, SIGNAL(stateChanged(int)), this, SLOT(onAutoHAlignChecked(int )));
    QApplication::connect(m_spinPhase, SIGNAL(valueChanged(int)), this, SLOT(onPhaseValueChanged(int )));
    QApplication::connect(m_btnAutoPhaseAdjust, SIGNAL(clicked(bool)), this, SLOT(onAutoPhaseAdjustClicked(bool)));

    QApplication::connect(m_btnPreferred, SIGNAL(clicked(bool)), this, SLOT(onPreferredTimingClicked(bool)));

    QApplication::connect(m_barHActive, SIGNAL(valueChanged(int)), this, SLOT(onHActiveChange(int )));
    QApplication::connect(m_barHTotal, SIGNAL(valueChanged(int)), this, SLOT(onHTotalChange(int )));
    QApplication::connect(m_barHOffset, SIGNAL(valueChanged(int)), this, SLOT(onHOffsetChange(int )));
    QApplication::connect(m_barVActive, SIGNAL(valueChanged(int)), this, SLOT(onVActiveChange(int )));
    QApplication::connect(m_barVOffset, SIGNAL(valueChanged(int)), this, SLOT(onVOffsetChange(int )));
    QApplication::connect(m_barClampPos, SIGNAL(valueChanged(int)), this, SLOT(onClampPosChange(int )));

    QApplication::connect(m_spinAspectX, SIGNAL(valueChanged(int)), this, SLOT(onAspectXValueChanged(int )));
    QApplication::connect(m_spinAspectY, SIGNAL(valueChanged(int)), this, SLOT(onAspectYValueChanged(int )));

    QApplication::connect(m_btnResetTiming, SIGNAL(clicked(bool)), this, SLOT(onResetTimingClicked(bool)));
    QApplication::connect(m_btnSaveTiming, SIGNAL(clicked(bool)), this, SLOT(onSaveTimingClicked(bool)));

    QApplication::connect(m_btnDeleteTimings, SIGNAL(clicked(bool)), this, SLOT(onTimingsDeleteClicked(bool)));
    QApplication::connect(m_btnAdd, SIGNAL(clicked(bool)), this, SLOT(onResolutionsAddClicked(bool)));
    QApplication::connect(m_btnModify, SIGNAL(clicked(bool)), this, SLOT(onResolutionsModifyClicked(bool)));
    QApplication::connect(m_btnDelete, SIGNAL(clicked(bool)), this, SLOT(onResolutionsDeleteClicked(bool)));

    QApplication::connect(m_tableTimings, SIGNAL(itemSelectionChanged()), this, SLOT(onTableTimingsItemClicked()));
    QApplication::connect(m_tableResolutions, SIGNAL(itemSelectionChanged()), this, SLOT(onTableResolutionsItemClicked()));

    m_bDeleteFlag = m_tableTimings->rowCount() == 0 ? true : false;
}

void CDlgTiming::UpdateTimingSettings()
{
    BOOLEAN bAutoHAlign = false;
    MWGetVideoAutoHAlign(g_capture.GetVideoHandle(), &bAutoHAlign);
    m_ckbAutoAlign->setChecked(bAutoHAlign);

    MW_RESULT xr;
    BOOLEAN bAuto = false;
    xr = MWGetVideoSamplingPhaseAutoAdjust(g_capture.GetVideoHandle(), &bAuto);
    m_ckbAutoSampling->setChecked(bAuto);
    m_spinPhase->setEnabled(!bAuto);
    m_spinPhase->setRange(0, 100);

    BYTE byPhase = 0;
    MWGetVideoSamplingPhase(g_capture.GetVideoHandle(), &byPhase);
    m_spinPhase->setValue(byPhase);
    m_shFile->ModifyFileSetPhase(m_spinPhase->value());

    MWCAP_INPUT_SPECIFIC_STATUS status;
    MWGetInputSpecificStatus(g_capture.GetVideoHandle(), &status);

    MWCAP_VIDEO_SYNC_INFO * pSyncInfo = &status.vgaComponentStatus.syncInfo;
    MWCAP_VIDEO_TIMING_SETTINGS * pSettings = &status.vgaComponentStatus.videoTimingSettings;
    MWCAP_VIDEO_TIMING * pTiming = &status.vgaComponentStatus.videoTiming;
    bool bValidTimings = status.bValid
        && (status.dwVideoInputType == MWCAP_VIDEO_INPUT_TYPE_VGA || status.dwVideoInputType == MWCAP_VIDEO_INPUT_TYPE_COMPONENT);

    m_btnAutoPhaseAdjust->setEnabled(bValidTimings);

    m_btnPreferred->setEnabled(bValidTimings);

    m_barHActive->setEnabled(bValidTimings);
    m_barHTotal->setEnabled(bValidTimings);
    m_barHOffset->setEnabled(bValidTimings);
    m_barVActive->setEnabled(bValidTimings);
    m_barVOffset->setEnabled(bValidTimings);
    m_barClampPos->setEnabled(bValidTimings);

    m_spinAspectX->setEnabled(bValidTimings);
    m_spinAspectY->setEnabled(bValidTimings);

    m_btnResetTiming->setEnabled(bValidTimings);
    m_btnSaveTiming->setEnabled(bValidTimings);

    if (!bValidTimings) {
        m_barHActive->setValue(0);
        m_barHTotal->setValue(0);
        m_barHOffset->setValue(0);
        m_barVActive->setValue(0);
        m_barVOffset->setValue(0);
        m_barClampPos->setValue(0);

        m_lblTimingInfo->setText("N/A");
        m_btnPreferred->setText("N/A");

        m_lblHActive->setText("N/A");
        m_lblHTotal->setText("N/A");
        m_lblHOffset->setText("N/A");
        m_lblVActive->setText("N/A");
        m_lblVOffset->setText("N/A");
        m_lblClampPos->setText("N/A");

        m_spinAspectX->setValue(4);
        m_spinAspectY->setValue(3);
        return;
    }

    m_btnPreferred->setText("Preferred timings");
    int nBefore = 0, nAfter = 0;
    GetVideoFPS(pSyncInfo->dwFrameDuration, pSyncInfo->bInterlaced, &nBefore, &nAfter);
    QString strInfo = QString("%1, %2x%3%4, %5.%6 Hz").arg(pTiming->dwType == MWCAP_VIDEO_TIMING_NONE ? "Custom" : GetVideoTimingType(pTiming->dwType)).arg(pSettings->cx).arg(pSettings->cy).arg(pSyncInfo->bInterlaced ? 'i' : 'p').arg(nBefore).arg(nAfter);

    m_lblTimingInfo->setText(strInfo);

    m_barHActive->setRange(512, 2048);
    m_barHActive->setValue(pSettings->cx);

    m_barVActive->setRange(1, pSyncInfo->wFrameLineCount);
    m_barVActive->setValue(pSettings->cy);

    m_barHTotal->setRange(512, 4095);
    m_barHTotal->setValue(pSettings->cxTotal);

    m_barHOffset->setRange(0, 2048);
    m_barHOffset->setValue(pSettings->x);

    m_barVOffset->setRange(0, 255);
    m_barVOffset->setValue(pSettings->y);

    m_barClampPos->setRange(0, 255);
    m_barClampPos->setValue(pSettings->byClampPos);

    m_spinAspectX->setValue(pSettings->wAspectX);
    m_spinAspectY->setValue(pSettings->wAspectY);

    m_lblHActive->setText(QString("%1 Pixels").arg(pSettings->cx));
    m_lblVActive->setText(QString("%1 Lines").arg(pSettings->cy));
    m_lblHTotal->setText(QString("%1 Pixels").arg(pSettings->cxTotal));
    m_lblHOffset->setText(QString("%1 Pixels").arg(pSettings->x));
    m_lblVOffset->setText(QString("%1 Lines").arg(pSettings->y));
    m_lblClampPos->setText(QString("%1 Pixels").arg(pSettings->byClampPos));
}

void CDlgTiming::UpdateTableTiming()
{
    m_tableTimings->clearContents();
    DWORD dwTimingCount = 0;
    MW_RESULT nRet = MWGetCustomVideoTimingsCount(g_capture.GetVideoHandle(), &dwTimingCount);

    DWORD dwBufferSize = 32;
    MWCAP_VIDEO_CUSTOM_TIMING szVideoTiming[32];
    nRet = MWGetCustomVideoTimingsArray(g_capture.GetVideoHandle(), szVideoTiming, &dwBufferSize);

    DWORD i = 0;
    DWORD j = 0;
    int nRowCount = dwTimingCount;
    for(i = 0; i < dwTimingCount; i++)
    {
        if(szVideoTiming[i].syncInfo.bySyncType == 0)
            nRowCount--;
    }
    m_tableTimings->setRowCount(nRowCount);

    i = 0;
    j = 0;
    for (DWORD i = 0; i < dwTimingCount; i++)
    {
        if(szVideoTiming[i].syncInfo.bySyncType == 0)
            continue;
        else
        {
            int nFieldRateX100 = 0;
            if (szVideoTiming[i].syncInfo.dwFrameDuration != 0)
                nFieldRateX100 = (int)(1000000000LL / szVideoTiming[i].syncInfo.dwFrameDuration);
            if (szVideoTiming[i].syncInfo.bInterlaced)
                nFieldRateX100 <<= 1;

            m_tableTimings->setItem(j, 0, new QTableWidgetItem(QString("%1x%2%3, %4.%5Hz").arg(szVideoTiming[i].videoTimingSettings.cx).arg(szVideoTiming[i].videoTimingSettings.cy).arg(szVideoTiming[i].syncInfo.bInterlaced ? "i" : "p").arg(nFieldRateX100 / 100).arg(nFieldRateX100 % 100)));
            m_tableTimings->setItem(j, 1, new QTableWidgetItem(QString("%1x%2").arg(szVideoTiming[i].videoTimingSettings.cxTotal).arg(szVideoTiming[i].syncInfo.wFrameLineCount)));
            QString strSyncType("");
            switch (szVideoTiming[i].syncInfo.bySyncType) {
            case VIDEO_SYNC_ALL:
                strSyncType = "ALL";
                break;
            case VIDEO_SYNC_HS_VS:
                strSyncType = "HS_VS";
                break;
            case VIDEO_SYNC_CS:
                strSyncType = "CS";
                break;
            case VIDEO_SYNC_EMBEDDED:
                strSyncType = "EMBEDDED";
                break;
            default:
                strSyncType = "";
                break;
            }
            m_tableTimings->setItem(j, 2, new QTableWidgetItem(strSyncType));

            j++;
        }
    }
}

void CDlgTiming::UpdateTableResolution()
{
    m_tableResolutions->clearContents();

    DWORD dwResolutionCount = 0;
    MW_RESULT nRet = MWGetCustomVideoResolutionsCount(g_capture.GetVideoHandle(), &dwResolutionCount);
    DWORD dwBufferSize = 32;
    MWCAP_SIZE szVideoResolution[32];
    nRet = MWGetCustomVideoResolutionsArray(g_capture.GetVideoHandle(), szVideoResolution, &dwBufferSize);
    m_tableResolutions->setRowCount(dwResolutionCount);
    for (int i = 0; i < dwResolutionCount; ++ i)
    {
        m_tableResolutions->setItem(i, 0, new QTableWidgetItem(QString("%1x%2").arg(szVideoResolution[i].cx).arg(szVideoResolution[i].cy)));
        //        m_tableResolutions->setItem(i, 1, new QTableWidgetItem(arrTableItems.at(i).value));
    }
}

void CDlgTiming::OnHScroll(int nPos, QScrollBar *pScrollBar)
{
    MWCAP_INPUT_SPECIFIC_STATUS status;
    MWGetInputSpecificStatus(g_capture.GetVideoHandle(), &status);

    MWCAP_VIDEO_SYNC_INFO * pSyncInfo = &status.vgaComponentStatus.syncInfo;
    MWCAP_VIDEO_TIMING_SETTINGS * pSettings = &status.vgaComponentStatus.videoTimingSettings;

    BOOLEAN bValidTimings = status.bValid
        && (status.dwVideoInputType == MWCAP_VIDEO_INPUT_TYPE_VGA || status.dwVideoInputType == MWCAP_VIDEO_INPUT_TYPE_COMPONENT);

    if (!bValidTimings)
        return;

    MWCAP_VIDEO_CUSTOM_TIMING timing;
    memcpy(&timing.syncInfo, pSyncInfo, sizeof(*pSyncInfo));
    memcpy(&timing.videoTimingSettings, pSettings, sizeof(*pSettings));

    WORD wValue = nPos;//(WORD)max(min(nPos, (UINT)scrollInfo.nMax), (UINT)scrollInfo.nMin);

    if (pScrollBar == m_barHActive) {
        if (timing.videoTimingSettings.cx == wValue)
            return;
        else if (wValue + pSettings->x > pSettings->cxTotal)
            timing.videoTimingSettings.cx = pSettings->cxTotal - pSettings->x;
        else
            timing.videoTimingSettings.cx = wValue;

        m_barHActive->setValue(timing.videoTimingSettings.cx);
        m_lblHActive->setText(QString("%1 Pixels").arg(timing.videoTimingSettings.cx));
    }
    else if (pScrollBar == m_barHTotal) {
        if (timing.videoTimingSettings.cxTotal == wValue)
            return;
        else if (wValue < (pSettings->x + pSettings->cx))
        {
            timing.videoTimingSettings.cxTotal = pSettings->x + pSettings->cx;
        }
        else {
            int cxTotalMax = ((165LL * pSyncInfo->dwFrameDuration) / (pSyncInfo->wFrameLineCount * 10));
            timing.videoTimingSettings.cxTotal = min(cxTotalMax, wValue);//min(cxTotalMax, wValue);
        }

        m_barHTotal->setValue(timing.videoTimingSettings.cxTotal);
        m_lblHTotal->setText(QString("%1 Pixels").arg(timing.videoTimingSettings.cxTotal));
    }
    else if (pScrollBar == m_barHOffset) {
        if (timing.videoTimingSettings.x == wValue)
            return;
        else if (wValue + pSettings->cx > pSettings->cxTotal)
            timing.videoTimingSettings.x = pSettings->cxTotal - pSettings->cx;
        else
            timing.videoTimingSettings.x = wValue;

        m_barHOffset->setValue(timing.videoTimingSettings.x);
        m_lblHOffset->setText(QString("%1 Pixels").arg(timing.videoTimingSettings.x));
    }
    else if (pScrollBar == m_barVActive) {
        if (timing.videoTimingSettings.cy == wValue)
            return;
        else if (wValue + pSettings->y > pSyncInfo->wFrameLineCount)
            timing.videoTimingSettings.cy = pSyncInfo->wFrameLineCount - pSettings->y;
        else
            timing.videoTimingSettings.cy = wValue;

        m_barVActive->setValue(timing.videoTimingSettings.cy);
        m_lblVActive->setText(QString("%1 Lines").arg(timing.videoTimingSettings.cy));
    }
    else if (pScrollBar == m_barVOffset) {
        if (timing.videoTimingSettings.y == wValue)
            return;
        else if (wValue + pSettings->cy > pSyncInfo->wFrameLineCount)
            timing.videoTimingSettings.y = pSyncInfo->wFrameLineCount - pSettings->cy;
        else
            timing.videoTimingSettings.y = wValue;

        m_barVOffset->setValue(timing.videoTimingSettings.y);
        m_lblVOffset->setText(QString("%1 Lines").arg(timing.videoTimingSettings.y));
    }
    else if (pScrollBar == m_barClampPos) {
        timing.videoTimingSettings.byClampPos = (BYTE)wValue;

        m_barClampPos->setValue(timing.videoTimingSettings.byClampPos);
        m_lblClampPos->setText(QString("%1 Pixels").arg(timing.videoTimingSettings.byClampPos));
    }

    MWSetCustomVideoTiming(g_capture.GetVideoHandle(), timing);
}

void CDlgTiming::onTimingStatuChanged(unsigned long long ullStatusBits)
{
    emit sigTimingStatuChanged(ullStatusBits);
}

//private
QString CDlgTiming::GetVideoTimingType( int nType )
{
    QString strType = "";
    switch (nType)
    {
    case 0x00:
        strType = "None";
        break;
    case 0x01:
        strType = "LEGACY";
        break;
    case 0x02:
        strType = "DMT";
        break;
    case 0x04:
        strType = "CEA";
        break;
    case 0x08:
        strType = "CVT";
        break;
    case 0x10:
        strType = "CVT";// RB");
        break;
    case 0x20:
        strType = "FAILSAFE";
        break;
    }
    return strType;
}

//slots
void CDlgTiming::onAutoSamplingChecked(int nStatus)
{
    bool bAuto = (nStatus == Qt::Checked) ? true : false;
    m_spinPhase->setEnabled(!bAuto);

    MWSetVideoSamplingPhaseAutoAdjust(g_capture.GetVideoHandle(), bAuto);
    if (bAuto) {
        MWSetVideoSamplingPhase(g_capture.GetVideoHandle(), 0xFF);
    }

//    m_shFile->ModifyFileSetPhase(m_spinPhase->value());

    if(bAuto == true)
        m_shFile->ModifyFileAutoSamp("true");
    else
        m_shFile->ModifyFileAutoSamp("false");


}

void CDlgTiming::onAutoHAlignChecked(int nStatus)
{
    bool bAutoHAlign = (nStatus == Qt::Checked) ? true : false;
    MWSetVideoAutoHAlign(g_capture.GetVideoHandle(), bAutoHAlign);

    if(bAutoHAlign == true)
        m_shFile->ModifyFileAutoHAlign("true");
    else
        m_shFile->ModifyFileAutoHAlign("false");
}

void CDlgTiming::onPhaseValueChanged(int nValue)
{
    MWSetVideoSamplingPhase(g_capture.GetVideoHandle(), nValue);

    m_shFile->ModifyFileSetPhase(nValue);
}

void CDlgTiming::onAutoPhaseAdjustClicked(bool bFlag)
{
    BYTE byPhase = 0xFF;
    MWSetVideoSamplingPhase(g_capture.GetVideoHandle(), byPhase);
}

void CDlgTiming::onPreferredTimingClicked(bool bFlag)
{
    long dwNum = MWCAP_VIDEO_MAX_NUM_PREFERRED_TIMINGS;
    MWCAP_VIDEO_TIMING szVideoTiming[MWCAP_VIDEO_MAX_NUM_PREFERRED_TIMINGS] = {0};
    MW_RESULT nRet = MWGetVideoPreferredTimingArray(g_capture.GetVideoHandle(), szVideoTiming, &dwNum);

   QMenu* m_menu = new QMenu(this);
    m_btnPreferred->setMenu(m_menu);
//    m_menu->clear();
    m_menu->setObjectName("objMenu");

    m_listPreferred.clear();
    for (DWORD i = 0; i < dwNum; ++ i) {
        //i, 30.00 Hz
        QString str = QString("%1, %2x%3%4").arg(GetVideoTimingType(szVideoTiming[i].dwType)).arg(szVideoTiming[i].wHActive).arg(szVideoTiming[i].bInterlaced ? szVideoTiming[i].wVActive * 2 : szVideoTiming[i].wVActive).arg(szVideoTiming[i].bInterlaced ? "i" : "p");
        QAction* acBulk = new QAction(str, this);
        connect(acBulk, SIGNAL(triggered()), this, SLOT(onPreferredItemClicked()));
        m_menu->addAction(acBulk);
        m_listPreferred.append(acBulk);
    }

    QPoint GlobalPoint(m_btnPreferred->mapToGlobal(QPoint(0, 0)));
    GlobalPoint.setY(GlobalPoint.y() + m_btnPreferred->height());
    m_menu->exec(GlobalPoint);

    for(int i = 0; i < m_listPreferred.size(); ++ i) {
        disconnect(m_listPreferred.at(i), SIGNAL(triggered()), this, SLOT(onPreferredItemClicked()));
        delete m_listPreferred.at(i);
    }
    delete m_menu;
}

void CDlgTiming::onHActiveChange(int nValue)
{
    m_lblHActive->setText(QString("%1").arg(nValue));
    OnHScroll(nValue, m_barHActive);
}

void CDlgTiming::onHTotalChange(int nValue)
{
    m_lblHTotal->setText(QString("%1").arg(nValue));
    OnHScroll(nValue, m_barHTotal);
}

void CDlgTiming::onHOffsetChange(int nValue)
{
    m_lblHOffset->setText(QString("%1").arg(nValue));
    OnHScroll(nValue, m_barHOffset);
}

void CDlgTiming::onVActiveChange(int nValue)
{
    m_lblVActive->setText(QString("%1").arg(nValue));
    OnHScroll(nValue, m_barVActive);
}

void CDlgTiming::onVOffsetChange(int nValue)
{
    m_lblVOffset->setText(QString("%1").arg(nValue));
    OnHScroll(nValue, m_barVOffset);
}

void CDlgTiming::onClampPosChange(int nValue)
{
    m_lblClampPos->setText(QString("%1").arg(nValue));
    OnHScroll(nValue, m_barClampPos);
}

void CDlgTiming::onAspectXValueChanged(int nValue)
{
    MWCAP_INPUT_SPECIFIC_STATUS status;
    MWGetInputSpecificStatus(g_capture.GetVideoHandle(), &status);

    MWCAP_VIDEO_SYNC_INFO * pSyncInfo = &status.vgaComponentStatus.syncInfo;
    MWCAP_VIDEO_TIMING_SETTINGS * pSettings = &status.vgaComponentStatus.videoTimingSettings;

    BOOLEAN bValidTimings = status.bValid
        && (status.dwVideoInputType == MWCAP_VIDEO_INPUT_TYPE_VGA || status.dwVideoInputType == MWCAP_VIDEO_INPUT_TYPE_COMPONENT);

    if (bValidTimings) {
        MWCAP_VIDEO_CUSTOM_TIMING timing;
        memcpy(&timing.syncInfo, pSyncInfo, sizeof(*pSyncInfo));
        memcpy(&timing.videoTimingSettings, pSettings, sizeof(*pSettings));

        timing.videoTimingSettings.wAspectX = nValue;
        MWSetCustomVideoTiming(g_capture.GetVideoHandle(), timing);
    }
}

void CDlgTiming::onAspectYValueChanged(int nValue)
{
    MWCAP_INPUT_SPECIFIC_STATUS status;
    MWGetInputSpecificStatus(g_capture.GetVideoHandle(), &status);

    MWCAP_VIDEO_SYNC_INFO * pSyncInfo = &status.vgaComponentStatus.syncInfo;
    MWCAP_VIDEO_TIMING_SETTINGS * pSettings = &status.vgaComponentStatus.videoTimingSettings;

    BOOLEAN bValidTimings = status.bValid
        && (status.dwVideoInputType == MWCAP_VIDEO_INPUT_TYPE_VGA || status.dwVideoInputType == MWCAP_VIDEO_INPUT_TYPE_COMPONENT);

    if (bValidTimings) {
        MWCAP_VIDEO_CUSTOM_TIMING timing;
        memcpy(&timing.syncInfo, pSyncInfo, sizeof(*pSyncInfo));
        memcpy(&timing.videoTimingSettings, pSettings, sizeof(*pSettings));

        timing.videoTimingSettings.wAspectY = nValue;
        MWSetCustomVideoTiming(g_capture.GetVideoHandle(), timing);
    }
}

void CDlgTiming::onResetTimingClicked(bool bFlag)
{
    if(m_bDeleteFlag == false)
    {
        MWCAP_VIDEO_CUSTOM_TIMING timing;
        memset(&timing, 0, sizeof(timing));
        MWSetCustomVideoTiming(g_capture.GetVideoHandle(), timing);
    }
    else
    {
        long dwNum = MWCAP_VIDEO_MAX_NUM_PREFERRED_TIMINGS;
        MWCAP_VIDEO_TIMING szVideoTiming[MWCAP_VIDEO_MAX_NUM_PREFERRED_TIMINGS] = {0};
        MW_RESULT nRet = MWGetVideoPreferredTimingArray(g_capture.GetVideoHandle(), szVideoTiming, &dwNum);
        if(dwNum > 0)
            nRet = MWSetVideoTiming(g_capture.GetVideoHandle(), szVideoTiming[0]);
        else
        {
            MWCAP_VIDEO_CUSTOM_TIMING timing;
            memset(&timing, 0, sizeof(timing));
            MWSetCustomVideoTiming(g_capture.GetVideoHandle(), timing);
        }
    }
}

BOOLEAN CDlgTiming::IsEqualSyncInfo(const MWCAP_VIDEO_SYNC_INFO * pSyncInfoCurr, const MWCAP_VIDEO_SYNC_INFO * pSyncInfo)
{
    // Match with sync info
    if (pSyncInfoCurr->bySyncType != pSyncInfo->bySyncType)
        return FALSE;

    DWORD dwChangeThreshold = 100;
    int nFrameDurationMin = (int)pSyncInfoCurr->dwFrameDuration - (int)dwChangeThreshold;
    int nFrameDurationMax = (int)pSyncInfoCurr->dwFrameDuration + (int)dwChangeThreshold;

    if (pSyncInfoCurr->bInterlaced != pSyncInfo->bInterlaced
        || pSyncInfoCurr->wVSyncLineCount > (pSyncInfo->wVSyncLineCount + 1)
        || pSyncInfo->wVSyncLineCount > (pSyncInfoCurr->wVSyncLineCount + 1)
        || pSyncInfoCurr->wFrameLineCount > (pSyncInfo->wFrameLineCount + 1)
        || pSyncInfo->wFrameLineCount > (pSyncInfoCurr->wFrameLineCount + 1)
        || ((int)pSyncInfo->dwFrameDuration < nFrameDurationMin)
        || ((int)pSyncInfo->dwFrameDuration > nFrameDurationMax)
        )
        return FALSE;

    return TRUE;
}

bool CDlgTiming::AddCustomTiming(const MWCAP_VIDEO_CUSTOM_TIMING * pTiming)
{
    MWCAP_VIDEO_CUSTOM_TIMING arrTimings[8];
    DWORD cCustomTimings = 8;
    DWORD nCount = 0;
    MWGetCustomVideoTimingsCount(g_capture.GetVideoHandle(), &nCount);
    MWGetCustomVideoTimingsArray(g_capture.GetVideoHandle(), arrTimings, &cCustomTimings);

    MWCAP_VIDEO_CUSTOM_TIMING * pTimings = arrTimings;
    int iOverwrite = -1;
    if(m_bDeleteFlag == false)
    {        
        for (int i = 0; i < nCount; i++)
        {
            if (IsEqualSyncInfo(&pTiming->syncInfo, &pTimings[i].syncInfo))
            {
                int nID = QMessageBox::information(NULL, "Title", "Confirm coverage?", QMessageBox::Yes | QMessageBox::No, QMessageBox::Yes);
                if (nID != QMessageBox::Yes)
                    return false;

                iOverwrite = i;
                break;
            }
        }
    }

    if (iOverwrite >= 0)
        memcpy(pTimings + iOverwrite, pTiming, sizeof(MWCAP_VIDEO_CUSTOM_TIMING));
    else
    {
        memcpy(pTimings + cCustomTimings, pTiming, sizeof(MWCAP_VIDEO_CUSTOM_TIMING));
        cCustomTimings++;
    }

    MW_RESULT nRet = MWSetCustomVideoTimingsArray(g_capture.GetVideoHandle(), arrTimings, cCustomTimings);
    return (nRet == MW_SUCCEEDED);

}

void CDlgTiming::onSaveTimingClicked(bool bFlag)
{
    MWCAP_INPUT_SPECIFIC_STATUS status;
    MWGetInputSpecificStatus(g_capture.GetVideoHandle(), &status);
    if (status.bValid == 1 && (status.dwVideoInputType == MWCAP_VIDEO_INPUT_TYPE_VGA || status.dwVideoInputType == MWCAP_VIDEO_INPUT_TYPE_COMPONENT))
    {
            MWCAP_VIDEO_CUSTOM_TIMING timing;
            memcpy(&timing.syncInfo, &status.vgaComponentStatus.syncInfo, sizeof(timing.syncInfo));
            memcpy(&timing.videoTimingSettings, &status.vgaComponentStatus.videoTimingSettings, sizeof(timing.videoTimingSettings));
            if (AddCustomTiming(&timing))
            {
                UpdateTableTiming();
            }
    }

    m_bDeleteFlag = false;
}

void CDlgTiming::onTimingsDeleteClicked(bool bFlag)
{
//    MWCAP_VIDEO_CUSTOM_TIMING timing;
    int nRowNum = m_tableTimings->currentRow();
    m_tableTimings->removeRow(nRowNum);

    MWCAP_VIDEO_CUSTOM_TIMING arrTimings[8];
    DWORD cCustomTimings = 8;
    DWORD nCount = 0;
    MWGetCustomVideoTimingsCount(g_capture.GetVideoHandle(), &nCount);
    MWGetCustomVideoTimingsArray(g_capture.GetVideoHandle(), arrTimings, &cCustomTimings);

    if (nCount != 1)
    {
        int nRowIndex = m_tableTimings->currentRow();
        for (DWORD i = nRowIndex; i < nCount; ++ i)
        {
            if(i != (nCount - 1))
            {
                arrTimings[i] = arrTimings[i + 1];
            }
            else
                continue;
        }

        -- nCount;
    }
    else
    {
        memset(&arrTimings[0], 0, sizeof(MWCAP_VIDEO_CUSTOM_TIMING));
    }

    MWSetCustomVideoTimingsArray(g_capture.GetVideoHandle(), arrTimings, nCount);

    m_bDeleteFlag = true;
}

void CDlgTiming::onResolutionsAddClicked(bool bFlag)
{
    if(m_tableResolutions->rowCount() == 0)
    {
        CDlgAddResolution dlg(-2);
        dlg.exec();
    }
    else
    {
        CDlgAddResolution dlg(-1);
        dlg.exec();
    }

    UpdateTableResolution();
}

void CDlgTiming::onResolutionsModifyClicked(bool bFlag)
{
    CDlgAddResolution dlg(m_tableResolutions->currentRow());
    dlg.exec();

    UpdateTableResolution();

    m_btnModify->setEnabled(false);
    m_btnDelete->setEnabled(false);
}

void CDlgTiming::onResolutionsDeleteClicked(bool bFlag)
{
    DWORD dwResolutionCount = 0;
    MW_RESULT nRet = MWGetCustomVideoResolutionsCount(g_capture.GetVideoHandle(), &dwResolutionCount);
    DWORD dwBufferSize = 32;
    MWCAP_SIZE szVideoResolution[32];
    nRet = MWGetCustomVideoResolutionsArray(g_capture.GetVideoHandle(), szVideoResolution, &dwBufferSize);

    if (dwResolutionCount != 1)
    {
        int nRowIndex = m_tableResolutions->currentRow();
        for (DWORD i = nRowIndex; i < dwResolutionCount; ++ i)
        {
            if(i != (dwResolutionCount - 1))
            {
                szVideoResolution[i] = szVideoResolution[i + 1];
            }
            else
                continue;
        }

        -- dwResolutionCount;
    }
    else
    {
        dwResolutionCount = 0;
//        memset(&szVideoResolution[0], 4097, sizeof(szVideoResolution[0]));
    }

    nRet = MWSetCustomVideoResolutionsArray(g_capture.GetVideoHandle(), szVideoResolution, dwResolutionCount);
    m_tableResolutions->removeRow(m_tableResolutions->currentRow());

    if(m_bDeleteFlag == true)
    {
        long dwNum = MWCAP_VIDEO_MAX_NUM_PREFERRED_TIMINGS;
        MWCAP_VIDEO_TIMING szVideoTiming[MWCAP_VIDEO_MAX_NUM_PREFERRED_TIMINGS] = {0};
        MW_RESULT nRet = MWGetVideoPreferredTimingArray(g_capture.GetVideoHandle(), szVideoTiming, &dwNum);
        if(dwNum > 0)
            nRet = MWSetVideoTiming(g_capture.GetVideoHandle(), szVideoTiming[0]);
        else
        {
            MWCAP_VIDEO_CUSTOM_TIMING timing;
            memset(&timing, 0, sizeof(timing));
            MWSetCustomVideoTiming(g_capture.GetVideoHandle(), timing);
        }
    }
}

void CDlgTiming::onTableResolutionsItemClicked()
{
    m_nSelTableResolution= m_tableResolutions->currentRow();
    int nItemsSelected = m_tableResolutions->selectedItems().count();

    if(m_nSelTableResolution >= 0 && nItemsSelected > 0)
    {
        m_btnDelete->setEnabled(true);
        m_btnModify->setEnabled(true);
    }
    else
    {
        m_btnDelete->setEnabled(false);
        m_btnModify->setEnabled(false);
    }
}

void CDlgTiming::onTableTimingsItemClicked()
{
    m_nSelTableTiming = m_tableTimings->currentRow();
    int nItemsSelected = m_tableTimings->selectedItems().count();

    if(m_nSelTableTiming >= 0 && nItemsSelected > 0)
    {
        m_btnDeleteTimings->setEnabled(true);
    }
    else
        m_btnDeleteTimings->setEnabled(false);
}

void CDlgTiming::onTimingStatuChangedMain(unsigned long long ullStatusBits)
{
    BOOLEAN bAutoSamplingPhase;
    MWGetVideoSamplingPhaseAutoAdjust(g_capture.GetVideoHandle(), &bAutoSamplingPhase);
    m_spinPhase->setEnabled(!bAutoSamplingPhase);
    m_ckbAutoSampling->setChecked(bAutoSamplingPhase);

    if ((ullStatusBits & MWCAP_NOTIFY_INPUT_SPECIFIC_CHANGE) != 0) {
        UpdateTimingSettings();
    }

    if ((ullStatusBits & MWCAP_NOTIFY_VIDEO_INPUT_SOURCE_CHANGE) != 0) {
        UpdateTimingSettings();
    }

    if ((ullStatusBits & MWCAP_NOTIFY_VIDEO_SAMPLING_PHASE_CHANGE) != 0) {
        BYTE bySamplingPhase;
        MWGetVideoSamplingPhase(g_capture.GetVideoHandle(), &bySamplingPhase);
        m_spinPhase->setValue(bySamplingPhase);
    }
}

void CDlgTiming::onFocusInResolution(bool bInFocus)
{
    if (bInFocus) {
        if (m_tableResolutions->selectedItems().count() > 0 && m_tableResolutions->hasFocus()
                && m_tableResolutions->currentRow() >= 0)
        {
            m_btnDelete->setEnabled(bInFocus);
            m_btnModify->setEnabled(bInFocus);
        }
    }
    else {
        if (!m_btnDelete->hasFocus() && !m_btnModify->hasFocus()) {
            m_btnDelete->setEnabled(bInFocus);
            m_btnModify->setEnabled(bInFocus);
            m_tableResolutions->setItemSelected(m_tableResolutions->item(m_nSelTableResolution, 0), false);
            m_nSelTableResolution = -1;
        }
    }
}

void CDlgTiming::onFocusInTiming(bool bInFocus)
{
    if (bInFocus) {
        if (m_tableTimings->selectedItems().count() > 0 && m_tableTimings->hasFocus()
                && m_tableTimings->currentRow() >= 0)
        {
            m_btnDeleteTimings->setEnabled(bInFocus);
        }
    }
    else {
        if (!m_btnDeleteTimings->hasFocus()) {
            m_btnDeleteTimings->setEnabled(bInFocus);
            m_tableTimings->setItemSelected(m_tableTimings->item(m_nSelTableTiming, 0), false);
            m_tableTimings->setItemSelected(m_tableTimings->item(m_nSelTableTiming, 1), false);
            m_tableTimings->setItemSelected(m_tableTimings->item(m_nSelTableTiming, 2), false);
            m_nSelTableTiming = -1;
        }
    }
}

void CDlgTiming::onPreferredItemClicked()
{
    QObject* obj = sender();
    int nIndex = -1;
    for(int i = 0; i < m_listPreferred.size(); ++ i) {
        if (m_listPreferred.at(i) == obj) {
            nIndex = i;
            break;
        }
    }
    if (nIndex != -1) {
        long dwNum = MWCAP_VIDEO_MAX_NUM_PREFERRED_TIMINGS;
        MWCAP_VIDEO_TIMING szVideoTiming[MWCAP_VIDEO_MAX_NUM_PREFERRED_TIMINGS] = {0};
        MW_RESULT nRet = MWGetVideoPreferredTimingArray(g_capture.GetVideoHandle(), szVideoTiming, &dwNum);

        nRet = MWSetVideoTiming(g_capture.GetVideoHandle(), szVideoTiming[nIndex]);
    }
}
