#include "cgenerateshfile.h"

CGenerateSHFile::CGenerateSHFile(QWidget *parent) : QProcess(parent)
{
    QString strHomePath = QString(QStandardPaths::standardLocations(QStandardPaths::DocumentsLocation).at(0));
    QString strCreatePath = strHomePath + "/deviceproperty";
    m_strPath = strCreatePath;
}


void CGenerateSHFile::ModifySHFileDeviceName(int nIndex)
{
    char szDeviceName[_MAX_PATH] = {0};
    QString strName = g_capture.GetCurrentDevicePath();
    strcpy(szDeviceName, strName.toLocal8Bit().data());

    int index = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/DEVICE_PATH=/c DEVICE_PATH=%1' %2/v4l2_control%3.sh").arg(strName).arg(m_strPath).arg(index);
    system(strCmd.toLocal8Bit().data());

}

void CGenerateSHFile::ModifyFileVideoInputType(char *type)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/VIDEOINPUTTYPE=/c VIDEOINPUTTYPE=%1' %2/v4l2_control%3.sh").arg(type).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());
}

void CGenerateSHFile::ModifyFileAudioInputType(char *type)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/AUDIOINPUT=/c AUDIOINPUT=%1' %2/v4l2_control%3.sh").arg(type).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());

}

void CGenerateSHFile::ModifyFileAspectXInput(int nValue)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/ASPECTXINPUT=/c ASPECTXINPUT=%1' %2/v4l2_control%3.sh").arg(nValue).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());
}


void CGenerateSHFile::ModifyFileAspectYInput(int nValue)
{

    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/ASPECTYINPUT=/c ASPECTYINPUT=%1' %2/v4l2_control%3.sh").arg(nValue).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());

}

void CGenerateSHFile::ModifyFileColorFmtInput(char *pFormat)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/COLORFMTINPUT=/c COLORFMTINPUT=%1' %2/v4l2_control%3.sh").arg(pFormat).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());
}

void CGenerateSHFile::ModifyFileQuanInput(char *pQuan)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/QUANTIZATIONINPUT=/c QUANTIZATIONINPUT=%1' %2/v4l2_control%3.sh").arg(pQuan).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());
}

void CGenerateSHFile::ModifyFileLowlatency(char *pValue)
{
}

void CGenerateSHFile::ModifyFileAutoScan(char * pAutoScan)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/AUTOSCAN=/c AUTOSCAN=%1' %2/v4l2_control%3.sh").arg(pAutoScan).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());
}

void CGenerateSHFile::ModifyFileLinkWithVideo(char *pLinkWithVideo)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/LINKWITHVIDEO=/c LINKWITHVIDEO=%1' %2/v4l2_control%3.sh").arg(pLinkWithVideo).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());
}

void CGenerateSHFile::ModifyFileSaveEdid()
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strEdidName = QString("%1/devicePropertyEdid%2.bin").arg(m_strPath).arg(nIndex);
    QString strDevicePath = g_capture.GetCurrentDevicePath();
    QString strCmd = QString("mwcap-control --edid-save %1 %2 1>/dev/null").arg(strEdidName).arg(strDevicePath);
    system(strCmd.toLocal8Bit().data());
}

void CGenerateSHFile::ModifyFileSaveTimingSettings()
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strTimingName = QString("%1/timingSettings%2.config").arg(m_strPath).arg(nIndex);
    QString strDevicePath = g_capture.GetCurrentDevicePath();
    QString strCmd = QString("mwcap-control --timing-save %1 %2 1>/dev/null").arg(strTimingName).arg(strDevicePath);
    system(strCmd.toLocal8Bit().data());
}


void CGenerateSHFile::ModifyFileAutoSamp(char *pAutoSampl)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/AUTO_SAMP=/c AUTO_SAMP=%1' %2/v4l2_control%3.sh").arg(pAutoSampl).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());
}

void CGenerateSHFile::ModifyFileAutoHAlign(char *pAutoHAlign)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/AUTO_HALIGN=/c AUTO_HALIGN=%1' %2/v4l2_control%3.sh").arg(pAutoHAlign).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());
}

void CGenerateSHFile::ModifyFileSetPhase(int nValue)
{
    int nIndex = g_capture.GetCurrentDeviceIndex();
    QString strCmd = QString("sed -i '/PHASE=/c PHASE=%1' %2/v4l2_control%3.sh").arg(nValue).arg(m_strPath).arg(nIndex);
    system(strCmd.toLocal8Bit().data());
}
