#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include "videorenderxcb.h"
#include "publicheaders.h"
#include "isignalnotify.h"
#include "cgenerateshfile.h"
#include <QMessageBox>
#include <QStandardPaths>
class CTabProperty;

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow, public ICaptureCallback, public ISignalNotify
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void CheckSHFile();
    void OpenVideo(int nIndex);

    //ISignalNotify
    virtual void onInputSourceChanged(unsigned long long ullStatusBits);

    //render
    bool CreateRender();
    bool SupportFourcc(unsigned int *dwFourcc);
    void OnCaptureCallback(VideoRenderImageBuf *pBuffer);
    void OnWndViewCallback(bool bUpdate);

protected:
    void CreateLayout();
    void closeEvent(QCloseEvent *event);

protected:
    CTabProperty    *m_tabProperty;
    QWidget         *m_wndView;
    QComboBox       *m_cmbDevice;

    //render
    VideoRenderXCB          *m_VideoRender;
    VideoRenderImageBuf     *m_pVideoBuffer;

    //modify shfile
    CGenerateSHFile     *m_shFile;

private slots:
    void onChannelIndexChanged(int nIndex);

private:
    Ui::MainWindow *ui;
};

#endif // MAINWINDOW_H
